Imports Microsoft.VisualBasic
Imports System
Imports System.Drawing
Imports System.Collections
Imports System.ComponentModel
Imports System.Windows.Forms
Imports System.Data
Imports O2S.Barcode4NET

Namespace CrystalReportsBarcodes
	''' <summary>
	''' Application's main form.
	''' </summary>
	Public Class MainForm
		Inherits System.Windows.Forms.Form
		Private crystalReportViewer As CrystalDecisions.Windows.Forms.CrystalReportViewer
		''' <summary>
		''' Required designer variable.
		''' </summary>
		Private components As System.ComponentModel.Container = Nothing

		Public Sub New()
			'
			' Required for Windows Form Designer support
			'
			InitializeComponent()

			'
			' TODO: Add any constructor code after InitializeComponent call
			'
		End Sub

		''' <summary>
		''' Clean up any resources being used.
		''' </summary>
		Protected Overrides Overloads Sub Dispose(ByVal disposing As Boolean)
			If disposing Then
				If Not components Is Nothing Then
					components.Dispose()
				End If
			End If
			MyBase.Dispose(disposing)
		End Sub

		#Region "Windows Form Designer generated code"
		''' <summary>
		''' Required method for Designer support - do not modify
		''' the contents of this method with the code editor.
		''' </summary>
		Private Sub InitializeComponent()
			Dim resources As System.ComponentModel.ComponentResourceManager = New System.ComponentModel.ComponentResourceManager(GetType(MainForm))
			Me.crystalReportViewer = New CrystalDecisions.Windows.Forms.CrystalReportViewer()
			Me.SuspendLayout()
			' 
			' crystalReportViewer
			' 
			Me.crystalReportViewer.ActiveViewIndex = -1
			Me.crystalReportViewer.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
			Me.crystalReportViewer.DisplayGroupTree = False
			Me.crystalReportViewer.Dock = System.Windows.Forms.DockStyle.Fill
			Me.crystalReportViewer.Location = New System.Drawing.Point(0, 0)
			Me.crystalReportViewer.Name = "crystalReportViewer"
			Me.crystalReportViewer.SelectionFormula = ""
			Me.crystalReportViewer.Size = New System.Drawing.Size(508, 273)
			Me.crystalReportViewer.TabIndex = 0
			Me.crystalReportViewer.ViewTimeSelectionFormula = ""
			' 
			' MainForm
			' 
			Me.AutoScaleBaseSize = New System.Drawing.Size(5, 14)
			Me.ClientSize = New System.Drawing.Size(508, 273)
			Me.Controls.Add(Me.crystalReportViewer)
			Me.Font = New System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, (CByte(0)))
			Me.Icon = (CType(resources.GetObject("$this.Icon"), System.Drawing.Icon))
			Me.Name = "MainForm"
			Me.Text = "Barcode4NET - Crystal Reports demo"
			Me.WindowState = System.Windows.Forms.FormWindowState.Maximized
'			Me.Load += New System.EventHandler(Me.MainForm_Load);
			Me.ResumeLayout(False)

		End Sub
		#End Region

		''' <summary>
		''' The main entry point for the application.
		''' </summary>
		<STAThread> _
		Shared Sub Main()
			Application.Run(New MainForm())
		End Sub

		Private Sub MainForm_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
			' Load the customers dataset.
			Dim customers As DataSet = New DataSet()
			' The path is relative to the exe file.
            customers.ReadXml("..\..\Samples\Windows Forms\CrystalReportsBarcodes\VBNET\Net 2.0\customers.net20.xml", XmlReadMode.ReadSchema)

			' Create a new column in the dataset that will store the barcode
			' The column name must match the CustomerIDBarcode column in Customers.xsd
			Dim dc As DataColumn = New DataColumn("CustomerIDBarcode", GetType(Byte() ))

			'Add the CustomerIDBarcode column to the DataTable
			customers.Tables(0).Columns.Add(dc)

            'Create a Code39 barcode object to fill the CustomerIDBarcode column
			Dim barcode As Code39Barcode = New Code39Barcode()
			barcode.DimensionUnit = XYDimensionUnit.Mil
			barcode.XDimension = 12
			barcode.YDimension = 500

			' Fill each row with the barcode image
			For Each dr As DataRow In customers.Tables(0).Rows
				barcode.Data = CStr(dr("CustomerID"))
				dr("CustomerIDBarcode") = barcode.GetImageData(BarcodeImageFormat.Png, 300)
			Next dr

			' Create the report and attach the data source
			Dim customersReport As CustomersReport = New CustomersReport()
			customersReport.SetDataSource(customers.Tables(0))

			' Display the report in the viewer
			crystalReportViewer.ReportSource = customersReport
		End Sub
	End Class
End Namespace
